/*
  Kko i krzyyk Online.
  CODE RULERS (c)
  www.coderulers.prv.pl

    Kko i Krzyyk Online - jak to dumnie brzmi :). A tak serjo to stworzyem
  t gr dla wasnej edukacji. Po prostu pewnego dnia zaczem si bawic
  komponentami w C++ Builder'ze o nazwie TClientSocket i TServerSocket. Efektem
  tej zabawy byo wasnie stworzenie tej gry. A dlaczego kko i krzyyk???
  Ano jest bardzo dobra! A tak na prawd - potrzebowaem najmniej dwu osobowej
  gry, ktra w dodatku jest na tyle prosta, e jej przeoenie do komputera
  nie zajmie mi p roku ;). Dlatego ta gierka powstaa w 5 dni i jak na razie
  jestem bardzo z niej zadowolony. A teraz cos dla pocztkujcych programistw:
  Kod rdowy!
                                                                Real_Noname
                                                          real_noname@wp.pl

*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ServerSocket1Listen(TObject *Sender,
      TCustomWinSocket *Socket)
{
/*
   To zdarzenie jest przypisane do komponentu TServerSocket1 do
   zdarzenia OnListen. Wystpuje ono kiedy ju serwer dziaa i nasuchuje na
   nowe poczenia.
*/
Memo1->Lines->Add("Czekanie na drugiego Gracza...");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ServerSocket1ClientConnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
/*
  To zdarzenie (OnClientConnect) z kolei nastpuje kiedy inny program znalaz
  Serwer i chce si z nim poczyc. Serwer komunikuje si z Klientem i nawi-
  zuje poczenie.
*/
Memo1->Lines->Add("Drugi Gracz Znaleziony, czenie...");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ServerSocket1Accept(TObject *Sender,
      TCustomWinSocket *Socket)
{
/*
  To zdarzenie (OnClientConnect) wystpuje kiedy Serwer nawie poczenie i
  je zakcepruje.
*/
Memo1->Lines->Add("Poczenie Udane!");
Edit1->Enabled = true;
bSendText->Enabled = true;
Memo1->Lines->Add("Jestes Gracz1, Zaczynamy gr!");
Memo1->Lines->Add("Trwa Twoja Tura...");
PlayerOne = true;
setPola(true);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::bConnectClick(TObject *Sender)
{
if(ClientSocket1->Active == false){
 ClientSocket1->Host = eSerwerHost->Text;
 eSerwerHost->Enabled = false;
 Button1->Enabled = false;
 ClientSocket1->Active = true;
 bConnect->Caption = "Przerwij";
 PlayerOne = false;}
else {
 ClientSocket1->Active = false;
 eSerwerHost->Enabled = true;
 Button1->Enabled = true;
 bConnect->Caption = "Podcz si do gry";}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ServerSocket1ClientDisconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{

//To zdarzenie (OnClientDisconnect) wystpuje gdy Klient serwera si rozczy.

Memo1->Lines->Add("Gracz si rozczy! Gra przerwana!");
Button1->Caption = "Stwrz gr";
eSerwerHost->Enabled = true;
bConnect->Enabled = true;
ServerSocket1->Active = false;
Edit1->Enabled = false;
bSendText->Enabled = false;
setPola(false);
ClearP();
}
//---------------------------------------------------------------------------

void TForm1::setPola(bool setTo)
{
//prosta funkcja, ktra przekazuje argument wszystkim polom(przyciskom) na planszy.
b1->Enabled = setTo;
b2->Enabled = setTo;
b3->Enabled = setTo;
b4->Enabled = setTo;
b5->Enabled = setTo;
b6->Enabled = setTo;
b7->Enabled = setTo;
b8->Enabled = setTo;
b9->Enabled = setTo;
}

void TForm1::AnaPack(AnsiString Analyze)
{
/*
  To ju trudniejsza procedura. Z argumentu (ze zmiennej Analyze) wycigane jest
  9 liczb, kada odpowiada kolejno: 0 - puste pole(mona kliknc), 1 - X
  (krzyyk) w polu (nie mona kliknc), 2 - O (kko) w polu (nie mona kliknc).
  Kolejnosc odczytu odpowiada kolejnym polom (od b1 do b9).
*/
switch(Analyze.SubString(1,1).ToInt())
        {
        case 0 : b1->Enabled = true;break;
        case 1 : b1->Caption = "X";b1->Enabled = false;break;
        case 2 : b1->Caption = "O";b1->Enabled = false;break;
        }
switch(Analyze.SubString(2,1).ToInt())
        {
        case 0 : b2->Enabled = true;break;
        case 1 : b2->Caption = "X";b2->Enabled = false;break;
        case 2 : b2->Caption = "O";b2->Enabled = false;break;
        }
switch(Analyze.SubString(3,1).ToInt())
        {
        case 0 : b3->Enabled = true;break;
        case 1 : b3->Caption = "X";b3->Enabled = false;break;
        case 2 : b3->Caption = "O";b3->Enabled = false;break;
        }
switch(Analyze.SubString(4,1).ToInt())
        {
        case 0 : b4->Enabled = true;break;
        case 1 : b4->Caption = "X";b4->Enabled = false;break;
        case 2 : b4->Caption = "O";b4->Enabled = false;break;
        }
switch(Analyze.SubString(5,1).ToInt())
        {
        case 0 : b5->Enabled = true;break;
        case 1 : b5->Caption = "X";b5->Enabled = false;break;
        case 2 : b5->Caption = "O";b5->Enabled = false;break;
        }
switch(Analyze.SubString(6,1).ToInt())
        {
        case 0 : b6->Enabled = true;break;
        case 1 : b6->Caption = "X";b6->Enabled = false;break;
        case 2 : b6->Caption = "O";b6->Enabled = false;break;
        }
switch(Analyze.SubString(7,1).ToInt())
        {
        case 0 : b7->Enabled = true;break;
        case 1 : b7->Caption = "X";b7->Enabled = false;break;
        case 2 : b7->Caption = "O";b7->Enabled = false;break;
        }
switch(Analyze.SubString(8,1).ToInt())
        {
        case 0 : b8->Enabled = true;break;
        case 1 : b8->Caption = "X";b8->Enabled = false;break;
        case 2 : b8->Caption = "O";b8->Enabled = false;break;
        }
switch(Analyze.SubString(9,1).ToInt())
        {
        case 0 : b9->Enabled = true;break;
        case 1 : b9->Caption = "X";b9->Enabled = false;break;
        case 2 : b9->Caption = "O";b9->Enabled = false;break;
        }
}

void TForm1::DoPackage()
{
/*
  To te ju bardziej zaawansowana funkcja. Analizuje kade pole i przygotowuje
  pakunek z 9 liczbami od 0 do 2, ktry nastpnie jest wysyany do prze-
  ciwnika. Ale najpierw jest analizowany przez kolejn funkcj, ktra nadaje
  przedrostek 1$ , by program mg j rozrnic od innych pakunkw (takich jak
  rozmowy, itp).
*/
AnsiString Temp;
Memo1->Lines->Add("Trwa Tura Przeciwnika...");
setPola(false);
if(b1->Caption == "") Temp += "0";
else if(b1->Caption == "X") Temp += "1";
else if(b1->Caption == "O") Temp += "2";
if(b2->Caption == "") Temp += "0";
else if(b2->Caption == "X") Temp += "1";
else if(b2->Caption == "O") Temp += "2";
if(b3->Caption == "") Temp += 0;
else if(b3->Caption == "X") Temp += "1";
else if(b3->Caption == "O") Temp += "2";
if(b4->Caption == "") Temp += "0";
else if(b4->Caption == "X") Temp += "1";
else if(b4->Caption == "O") Temp += "2";
if(b5->Caption == "") Temp += "0";
else if(b5->Caption == "X") Temp += "1";
else if(b5->Caption == "O") Temp += "2";
if(b6->Caption == "") Temp += "0";
else if(b6->Caption == "X") Temp += "1";
else if(b6->Caption == "O") Temp += "2";
if(b7->Caption == "") Temp += "0";
else if(b7->Caption == "X") Temp += "1";
else if(b7->Caption == "O") Temp += "2";
if(b8->Caption == "") Temp += "0";
else if(b8->Caption == "X") Temp += "1";
else if(b8->Caption == "O") Temp += "2";
if(b9->Caption == "") Temp += "0";
else if(b9->Caption == "X") Temp += "1";
else if(b9->Caption == "O") Temp += "2";
//Sprawd ponisz funkcj
Temp = Check(Temp);

if(PlayerOne == true)
/*
  Pamitaj, e serwer moe miec setki pocze, dlatego trzeba pamitac
  o wybraniu ktregos przed wysaniem.
*/
 ServerSocket1->Socket->Connections[0]->SendText(Temp);
else
 ClientSocket1->Socket->SendText(Temp);
}
/*
  Niej jest sterta zdarze przypisanych do przyciskw, ktre nazywam polami
  gry. Jeeli grajcy jest pierwszym graczem - stawia X, inaczej O. Pniej
  nastpuje procedura tworzenia paczki do wysania.
*/
void __fastcall TForm1::b1Click(TObject *Sender)
{
if(PlayerOne == true)
 b1->Caption = "X";
else b1->Caption = "O";
DoPackage();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::b2Click(TObject *Sender)
{
if(PlayerOne == true)
 b2->Caption = "X";
else b2->Caption = "O";
DoPackage();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::b3Click(TObject *Sender)
{
if(PlayerOne == true)
 b3->Caption = "X";
else b3->Caption = "O";
DoPackage();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::b4Click(TObject *Sender)
{
if(PlayerOne == true)
 b4->Caption = "X";
else b4->Caption = "O";
DoPackage();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::b5Click(TObject *Sender)
{
if(PlayerOne == true)
 b5->Caption = "X";
else b5->Caption = "O";
DoPackage();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::b6Click(TObject *Sender)
{
if(PlayerOne == true)
 b6->Caption = "X";
else b6->Caption = "O";
DoPackage();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::b7Click(TObject *Sender)
{
if(PlayerOne == true)
 b7->Caption = "X";
else b7->Caption = "O";
DoPackage();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::b8Click(TObject *Sender)
{
if(PlayerOne == true)
 b8->Caption = "X";
else b8->Caption = "O";
DoPackage();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::b9Click(TObject *Sender)
{
if(PlayerOne == true)
 b9->Caption = "X";
else b9->Caption = "O";
DoPackage();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ServerSocket1ClientRead(TObject *Sender,
      TCustomWinSocket *Socket)
{

AnsiString Temp = Socket->ReceiveText();
if(Temp.SubString(1,2) == "1$"){
        Memo1->Lines->Add("Trwa Twoja Tura...");
        AnaPack(Temp.SubString(3,9));}
else if (Temp.SubString(1,2) == "2$")
 {
 Memo2->Lines->Add("Gracz2: "+Temp.Delete(1,2));
 }
else if (Temp.SubString(1,3) == "3$1")
 {
 ShowMessage("Przegraes!!!");
 ClearP();
 setPola(false);
 }
else if (Temp.SubString(1,3) == "3$0")
 {
 ShowMessage("Remis!!!");
 ClearP();
 setPola(false);
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocket1Read(TObject *Sender,
      TCustomWinSocket *Socket)
{
AnsiString Temp = Socket->ReceiveText();
if(Temp.SubString(1,2) == "1$"){
        Memo1->Lines->Add("Trwa Twoja Tura...");
        AnaPack(Temp.SubString(3,9));}
else if (Temp.SubString(1,2) == "2$")
 {
 Memo2->Lines->Add("Gracz1: "+Temp.Delete(1,2));
 }
else if (Temp.SubString(1,2) == "3$")
 {
 if (Temp.SubString(3,1) == "1"){
  ShowMessage("Przegraes!!!");
  ClearP();
  setPola(false);
  }
 else {
  ShowMessage("Remis!!!");
  ClearP();
  setPola(false);
  }
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocket1Lookup(TObject *Sender,
      TCustomWinSocket *Socket)
{
Memo1->Lines->Add("Szukanie...");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocket1Connecting(TObject *Sender,
      TCustomWinSocket *Socket)
{
Memo1->Lines->Add("Podanczanie...");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocket1Connect(TObject *Sender,
      TCustomWinSocket *Socket)
{
Memo1->Lines->Add("Poczony!");
Edit1->Enabled = true;
bSendText->Enabled = true;
Memo1->Lines->Add("Jestes Gracz2, Zaczynamy gr!");
Memo1->Lines->Add("Trwa Tura Przeciwnika...");
setPola(false);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
if(ServerSocket1->Active == false){
 Button1->Caption = "Przerwij";
 eSerwerHost->Enabled = false;
 bConnect->Enabled = false;
 ServerSocket1->Active = true;
 PlayerOne = true;}
else {
 Button1->Caption = "Stwrz gr";
 eSerwerHost->Enabled = true;
 bConnect->Enabled = true;
 ServerSocket1->Active = false;}
}
//---------------------------------------------------------------------------

void TForm1::ClearP()
{
b1->Caption = "";
b2->Caption = "";
b3->Caption = "";
b4->Caption = "";
b5->Caption = "";
b6->Caption = "";
b7->Caption = "";
b8->Caption = "";
b9->Caption = "";
}

AnsiString TForm1::Check(AnsiString CheckThis)
{
int waswin = 0;
int wynik = 0;
if(PlayerOne == true){
 if (CheckThis.SubString(1,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(2,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(3,1).ToInt() == 1) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(4,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(5,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(6,1).ToInt() == 1) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(7,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(8,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(9,1).ToInt() == 1) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(1,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(4,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(7,1).ToInt() == 1) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(2,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(5,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(8,1).ToInt() == 1) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(3,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(6,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(9,1).ToInt() == 1) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(1,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(5,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(9,1).ToInt() == 1) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(3,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(5,1).ToInt() == 1) wynik++;
 if (CheckThis.SubString(7,1).ToInt() == 1) wynik++;
 if (wynik < 3)wynik = 0;
 if (wynik != 0)waswin = 1;
/*
 if(((CheckThis.SubString(1,1).ToInt() + CheckThis.SubString(2,1).ToInt() + CheckThis.SubString(3,1).ToInt())==3)) waswin = 1;
 else if((CheckThis.SubString(4,1).ToInt() + CheckThis.SubString(5,1).ToInt() + CheckThis.SubString(6,1).ToInt())==3) waswin = 1;
 else if((CheckThis.SubString(7,1).ToInt() + CheckThis.SubString(8,1).ToInt() + CheckThis.SubString(9,1).ToInt())==3) waswin = 1;
 else if((CheckThis.SubString(1,1).ToInt() + CheckThis.SubString(4,1).ToInt() + CheckThis.SubString(7,1).ToInt())==3) waswin = 1;
 else if((CheckThis.SubString(2,1).ToInt() + CheckThis.SubString(5,1).ToInt() + CheckThis.SubString(8,1).ToInt())==3) waswin = 1;
 else if((CheckThis.SubString(3,1).ToInt() + CheckThis.SubString(6,1).ToInt() + CheckThis.SubString(9,1).ToInt())==3) waswin = 1;
 else if((CheckThis.SubString(1,1).ToInt() + CheckThis.SubString(5,1).ToInt() + CheckThis.SubString(9,1).ToInt())==3) waswin = 1;
 else if((CheckThis.SubString(3,1).ToInt() + CheckThis.SubString(5,1).ToInt() + CheckThis.SubString(7,1).ToInt())==3) waswin = 1;
*/
}
else {
 if (CheckThis.SubString(1,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(2,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(3,1).ToInt() == 2) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(4,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(5,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(6,1).ToInt() == 2) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(7,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(8,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(9,1).ToInt() == 2) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(1,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(4,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(7,1).ToInt() == 2) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(2,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(5,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(8,1).ToInt() == 2) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(3,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(6,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(9,1).ToInt() == 2) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(1,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(5,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(9,1).ToInt() == 2) wynik++;
 if (wynik < 3)wynik = 0;
 if (CheckThis.SubString(3,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(5,1).ToInt() == 2) wynik++;
 if (CheckThis.SubString(7,1).ToInt() == 2) wynik++;
 if (wynik < 3)wynik = 0;
 if (wynik != 0)waswin = 1;
/*
 if(((CheckThis.SubString(1,1).ToInt() + CheckThis.SubString(2,1).ToInt() + CheckThis.SubString(3,1).ToInt())==6)) waswin = 1;
 else if(((CheckThis.SubString(4,1).ToInt() + CheckThis.SubString(5,1).ToInt() + CheckThis.SubString(6,1).ToInt())==6)) waswin = 1;
 else if(((CheckThis.SubString(7,1).ToInt() + CheckThis.SubString(8,1).ToInt() + CheckThis.SubString(9,1).ToInt())==6)) waswin = 1;
 else if(((CheckThis.SubString(1,1).ToInt() + CheckThis.SubString(4,1).ToInt() + CheckThis.SubString(7,1).ToInt())==6)) waswin = 1;
 else if(((CheckThis.SubString(2,1).ToInt() + CheckThis.SubString(5,1).ToInt() + CheckThis.SubString(8,1).ToInt())==6)) waswin = 1;
 else if(((CheckThis.SubString(3,1).ToInt() + CheckThis.SubString(6,1).ToInt() + CheckThis.SubString(9,1).ToInt())==6)) waswin = 1;
 else if(((CheckThis.SubString(1,1).ToInt() + CheckThis.SubString(5,1).ToInt() + CheckThis.SubString(9,1).ToInt())==6)) waswin = 1;
 else if(((CheckThis.SubString(3,1).ToInt() + CheckThis.SubString(5,1).ToInt() + CheckThis.SubString(7,1).ToInt())==6)) waswin = 1;
*/
}

if (CheckThis.AnsiPos("0") == 0) waswin = -1;

if (waswin == 0) return "1$" + CheckThis;
else if (waswin == 1)
 {
 ShowMessage("Wygraes!!!");
 ClearP();
 setPola(false);
 return "3$1";
 }
else if (waswin == -1)
 {
 ShowMessage("Remis!!!");
 ClearP();
 setPola(false);
 return "3$0";
 }
else return "ERROR";
}

void __fastcall TForm1::bSendTextClick(TObject *Sender)
{
if (!(Edit1->Text.IsEmpty())){
 if(PlayerOne == true){
  Memo2->Lines->Add("Gracz1: " + Edit1->Text);
  ServerSocket1->Socket->Connections[0]->SendText("2$"+Edit1->Text);
  }
 else {
  Memo2->Lines->Add("Gracz2: " + Edit1->Text);
  ClientSocket1->Socket->SendText("2$"+Edit1->Text);
  }
 Edit1->Text = "";
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocket1Disconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
Memo1->Lines->Add("Rozczyes si! Gra przerwana!");
eSerwerHost->Enabled = true;
Button1->Enabled = true;
bConnect->Caption = "Podcz si do gry";
Edit1->Enabled = false;
bSendText->Enabled = false;
setPola(false);
ClearP();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ServerSocket1ClientError(TObject *Sender,
      TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode)
{
Memo1->Lines->Add("Nastpi bd! Nr bdu: "+IntToStr(ErrorCode));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocket1Error(TObject *Sender,
      TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode)
{
Memo1->Lines->Add("Nastpi bd! Nr bdu: "+IntToStr(ErrorCode));
}
//---------------------------------------------------------------------------


